#include	<stdio.h>
#include	<string.h>
#include	<malloc.h>

/*	őO`PT	*/
static	char	*Str[15];
static	int		S_len[15] = {
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0  };

#ifdef	PROTOTYPE1
char *string_ptr(int);
void string_ptr_set(char *,int);
int string_set(char *,int);
int string_find(char *,int);
void string_del(char *,int);
void string_init(int);
int string_get(char *,int,int);
#else
char *string_ptr();
void string_ptr_set();
int string_set();
int string_find();
void string_del();
void string_init();
int string_get();
#endif

/*	f[^|C^̏Ɖ	*/
#ifdef	PROTOTYPE1
char	*string_ptr( int men )
#else
char	*string_ptr( men )
int		men;
#endif
{
	return( Str[men] );
}

/*	f[^|C^̊Oݒ	*/
#ifdef	PROTOTYPE1
void	string_ptr_set( char *msg, int men )
#else
void	string_ptr_set( msg, men )
char	*msg;
int		men;
#endif
{
	strcpy( Str[men], msg );
}

/*	f[^̊i[	*/
#ifdef	PROTOTYPE1
int		string_set( char *msg, int men )
#else
int		string_set( msg, men )
char	*msg;
int		men;
#endif
{
	int		len, n;
	char	*p;

	len = strlen( msg );
	if( S_len[men] == 0 ) {
		/*	VKȂGAmۂ	*/
		if( (Str[men]=(char *)malloc( len + 256 )) == NULL ) {
			return( -1 );
		}
		S_len[men] = len + 256;
		sprintf( Str[men], "%c%s", (unsigned char)len, msg );
		return( 0 );
	}
	p = Str[men];
	while( (n=(unsigned char)*p) != 0x00 ) {
		p++;
		if( n == len && strncmp( p, msg, len ) == 0 ) {
			/*	ɓo^Ă	*/
			return( 0 );
		}
		p += n;
	}
	/*	ǉo^	*/
	if( S_len[men] <= ( (int)strlen( Str[men] ) + len + 2 ) ) {
		if( (p=(char *)malloc( strlen( Str[men] ) + len + 256 )) == NULL ) {
			return( -1 );
		}
		S_len[men] = strlen( Str[men] ) + len + 256;
		strcpy( p, Str[men] );
		free( Str[men] );
		Str[men] = p;
	}
	sprintf( &Str[men][strlen(Str[men])], "%c%s", (unsigned char)len, msg );
	return( 0 );
}

/*	f[^̌	*/
#ifdef	PROTOTYPE1
int		string_find( char *msg, int men )
#else
int		string_find( msg, men )
char	*msg;
int		men;
#endif
{
	int		len, n;
	char	*p;

	if( S_len[men] == 0 ) {
		return( -1 );
	}
	len = strlen( msg );
	p = Str[men];
	while( (n=(unsigned char)*p) != 0x00 ) {
		p++;
		if( n == len && strncmp( p, msg, len ) == 0 ) {
			return( 0 );
		}
		p += n;
	}
	return( -1 );
}

/*	f[^̍폜	*/
#ifdef	PROTOTYPE1
void	string_del( char *msg, int men )
#else
void	string_del( msg, men )
char	*msg;
int		men;
#endif
{
	int		len, n;
	char	*p;

	if( S_len[men] == 0 ) {
		return;
	}
	len = strlen( msg );
	p = Str[men];
	while( (n=(unsigned char)*p) != 0x00 ) {
		p++;
		if( n == len && strncmp( p, msg, len ) == 0 ) {
			/*	o^Ă̂ō폜	*/
			strcpy( (p-1), (p+n) );
			return;
		}
		p += n;
	}
}

/*	GȀ	*/
#ifdef	PROTOTYPE1
void	string_init( int men )
#else
void	string_init( men )
int		men;
#endif
{
	if( S_len[men] != 0 ) {
		free( Str[men] );
		S_len[men] = 0;
	}
}

/*	f[^̎肾	*/
/*	^[l  f[^L(1)Af[^(0)Aُ(-1)	*/
#ifdef	PROTOTYPE1
int		string_get( char *msg, int men, int start )
#else
int		string_get( msg, men, start )
char	*msg;	/*	ʊi[obt@	*/
int		men;	/*	ʔ͈̓`FbN	*/
int		start;	/*	͂OAp͂P	*/
#endif
{
	int		n;
	static	char	*p = NULL;

	if( S_len[men] == 0 ) {
		return( 0 );
	}
	if( start == 0 ) {
		p = Str[men];
	}
	if( p == NULL ) {
		return( -1 );
	}
	if( (n=(unsigned char)*p) != 0x00 ) {
		p++;
		strncpy( msg, p, n );
		msg[n] = 0x00;
		p += n;
		return( 1 );
	}
	return( 0 );
}

#ifdef	DEBUG_MAIN
int		main()
{
	char	msg[256];

	printf( "set status %d\n", string_set( "AAA111", 0 ) );
	printf( "set status %d\n", string_set( "BB22", 0 ) );
	printf( "set status %d\n", string_set( "C3", 0 ) );
	printf( "set status %d\n", string_set( "C3", 0 ) );
	printf( "set status %d\n", string_set( "D5555", 0 ) );
	printf( "set status %d\n", string_set( "AAA111", 1 ) );
	printf( "set status %d\n", string_set( "BB22", 1 ) );
	printf( "set status %d\n", string_set( "C3", 2 ) );
	printf( "set status %d\n", string_set( "D5555", 2 ) );

	printf( "find status %d\n", string_find( "C3", 0 ) );
	printf( "find status %d\n", string_find( "C5", 0 ) );
	printf( "find status %d\n", string_find( "C3", 2 ) );

	printf( "\n" );
	if( string_get( msg, 0, 0 ) == 1 ) {
		do {
			printf( "[%s]\n", msg );
		} while( string_get( msg, 0, 1 ) == 1 );
	}
	printf( "\n" );
	if( string_get( msg, 1, 0 ) == 1 ) {
		do {
			printf( "[%s]\n", msg );
		} while( string_get( msg, 1, 1 ) == 1 );
	}
	printf( "\n" );
	if( string_get( msg, 2, 0 ) == 1 ) {
		do {
			printf( "[%s]\n", msg );
		} while( string_get( msg, 2, 1 ) == 1 );
	}
	printf( "\n" );
	string_del( "BB22", 0 );
	if( string_get( msg, 0, 0 ) == 1 ) {
		do {
			printf( "[%s]\n", msg );
		} while( string_get( msg, 0, 1 ) == 1 );
	}
	string_init( 0 );
	printf( "\n" );
	if( string_get( msg, 0, 0 ) == 1 ) {
		do {
			printf( "[%s]\n", msg );
		} while( string_get( msg, 0, 1 ) == 1 );
	}
	string_init( 1 );
	string_init( 2 );
	return( 0 );
}
#endif
