#include	<stdio.h>
#include	<string.h>
#include	<malloc.h>
#include	<ctype.h>
#include	"sym.h"

/* 2000/10/09 dotƔf悤ɏC */

typedef	unsigned	long	ulong;
typedef	unsigned	char	uchar;

/* 2000/08/04  1024 -> 2048 */
/* 2004/11/22  2048 -> 8192 V3.61 */
/* Ver.3.70 */
#ifdef	DOS_VERSION
#define	SYM_MAX	2048
#else
#define	SYM_MAX	8192
#endif

/*	Sym2 ɂ͏ϊĂȂ SYM_STR ̃f[^i[	*/
char	Sym[SYM_MAX], Sym2[256];
int		Msg_check1 = 1;		/*	1:"message" 𔻒肷	*/
int		Msg_check2 = 0;		/*	1:'message' 𔻒肷	*/
int		Sym_ncd;/*	 or ÃR[hPoCg	*/
				/*	x(:)A#0  #9 ̕ϐp	*/
int		Sym_adr;	/*	擪oCgڂ̕񂩁H	*/
int		Sym_str_mode = 0;	/* 0:normal,1:@string@SYM_OTHERƂĈ */

char	Sym_bf[SYM_MAX];
static	int		Sym_ll;				/*	[ǂݍݎ̈ʒup	*/
static	int		Sym_la;				/*	[ǂݍݎ̈ʒup	*/

/* Ver.3.71 */
static	int		Sym_ll_save;		/*	Sym_ll̑ҔGA	*/
static	int		Sym_la_save;		/*	Sym_lȃҔGA	*/

#ifdef	PROTOTYPE1
char *sym_save (void);
int sym_load (char *);
static int bin_to_dec (char *,ulong *);
static int oct_to_dec (char *,ulong *);
void sym_restart(void);
void sym_pack(int,char);
int sym_endcheck(void);
int sym_set (char *);
int sym_get (void);
int sym_pop (void);
#else
char *sym_save ();
int sym_load ();
static int bin_to_dec ();
static int oct_to_dec ();
void sym_restart();
void sym_pack();
int sym_endcheck();
int sym_set ();
int sym_get ();
int sym_pop ();
#endif

/*	݂̃f[^ malloc GAɑޔ	*/
#ifdef	PROTOTYPE1
char	*sym_save( void )
#else
char	*sym_save()
#endif
{
	char	*ptr;

	if( (ptr = (char *)malloc( sizeof(int) * 2 + strlen( Sym_bf ) + 1 )) == NULL ) {
		return( NULL );
	}
	memcpy( ptr, (char *)&Sym_ll, sizeof(int) );
	memcpy( &ptr[sizeof(int)], (char *)&Sym_la, sizeof(int) );
	strcpy( &ptr[sizeof(int)*2], Sym_bf );
	return( ptr );
}

/*	ޔĂf[^𕜋A	*/
#ifdef	PROTOTYPE1
int		sym_load( char *ptr )
#else
int		sym_load( ptr )
char	*ptr;
#endif
{
	if( ptr == NULL )	return( -1 );
	memcpy( (char *)&Sym_ll, ptr, sizeof(int) );
	memcpy( (char *)&Sym_la, &ptr[sizeof(int)], sizeof(int) );
	strcpy( Sym_bf, &ptr[sizeof(int)*2] );
	free( ptr );
	return( 0 );
}

/*	2i10iɂ	*/
#ifdef	PROTOTYPE1
static	int		bin_to_dec( char *bf, ulong *ans )
#else
static	int		bin_to_dec( bf, ans )
char	*bf;
ulong	*ans;
#endif
{
	int		len, n, bit;

	len = strlen( bf );
	*ans = 0L;
	bit = 0;
	for( n=(len-1); n>=0; n-- ) {
		switch( bf[n] ) {
			case	'1':	*ans += (long)(1L << bit);	break;
			case	'0':	break;
			default:		return( -1 );
		}
		bit++;
	}
	return( 0 );
}

/*	16i10iɂ	*/
#ifdef	PROTOTYPE1
static	int		oct_to_dec( char *bf, ulong *ans )
#else
static	int		oct_to_dec( bf, ans )
char	*bf;
ulong	*ans;
#endif
{
	int		len, n, oct;
	static	unsigned	long	tbl[20] = {1L,8L,64L,512L,4096L,32768L,262144L,
				2097152L,16777216L,134217728L,1073741824L};

	len = strlen( bf );
	*ans = 0L;
	oct = 0;
	for( n=(len-1); n>=0; n-- ) {
		if( bf[n] >= '0' && bf[n] <= '7' ) {
			*ans += ( (long)(bf[n]-'0')*tbl[oct] );
		} else {
			return( -1 );
		}
		oct++;
	}
	return( 0 );
}

#ifdef	PROTOTYPE1
void	sym_restart( void )
#else
void	sym_restart()
#endif
{
	Sym_la = 0;
	return;
}

#ifdef	PROTOTYPE1
void	sym_pack( int len, char c )
#else
void	sym_pack( len, c )
int		len;
char	c;
#endif
{
	if( c == 0 ) {
		/* ɓǂݍ񂾕SđOɋl߂ꍇ */
		strcpy( Sym_bf, &Sym_bf[Sym_la+len] );
	} else {
		/* 擪Ɏw肳ꂽPtđOɋl߂ꍇ */
		/* "label:ope" -> " ope" ƕϊ鎖ɂAĊԈ */
		/* opexƔ肳Ȃ悤ɂ */
		strcpy( &Sym_bf[1], &Sym_bf[Sym_la+len] );
		Sym_bf[0] = c;
	}
	Sym_ll = strlen( Sym_bf );
	Sym_la = 0;
	return;
}

#ifdef	PROTOTYPE1
int		sym_endcheck( void )
#else
int		sym_endcheck()
#endif
{
	if( Sym_ll == Sym_la )	return( 0 );
	return( -1 );
}

#ifdef	PROTOTYPE1
int		sym_set( char *dat )
#else
int		sym_set( dat )
char	*dat;
#endif
{
	if( strlen( dat ) >= SYM_MAX )	return( -1 );
	strcpy( Sym_bf, dat );
	Sym_ll = strlen( Sym_bf );
	Sym_la = 0;
	return( 0 );
}
#ifdef	PROTOTYPE1
int		sym_pop( void )
#else
int		sym_pop()
#endif
{
	Sym_ll = Sym_ll_save;	/*	Sym_ll̕A	*/
	Sym_la = Sym_la_save;	/*	Sym_la̕A	*/
	return(0);
}

#ifdef	PROTOTYPE1
int		sym_get( void )
#else
int		sym_get()
#endif
{
	int		dt, m, n, flg;
	ulong	tmp_dt;

	Sym_ncd = 0;
	*Sym = 0x00;
	Sym_ll_save = Sym_ll;	/*	Sym_ll̑Ҕ	*/
	Sym_la_save = Sym_la;	/*	Sym_lȃҔ	*/

	for( ;; ) {
		if( Sym_ll == Sym_la ) {
			return( SYM_END );
		}
		dt = (int)(Sym_bf[Sym_la++]);
		switch( dt ) {
		/*	󔒕XLbv	*/
		case	' ':
		case	'\t':
		case	0xd:	/*	MS-DOS ̉sR[hp	*/
			break;
		/*	s	*/
		case	'\n':
			return( SYM_LINEEND );
		/*	 or "	*/
		case	'"':
			if( Msg_check1 ) {	/*	񔻒肷Ȃ	*/
				n = 0;
				Sym[n++] = (uchar)dt;
				for( ;; ) {
					if( Sym_ll == Sym_la ) {
						Sym[1] = 0x00;
						Sym_la -= (n-1);
						return( SYM_OTHER );
					}
					Sym[n] = (uchar)(Sym_bf[Sym_la++]);
					if( Sym[n++] == '"' ) {
						Sym[n] = 0x00;
						break;
					}
				}
				return( SYM_MSG );
			}
			Sym[0] = dt;
			Sym[1] = 0x00;
			return( SYM_OTHER );
		/*	 or etc	*/
		case	'\'':
			if( Msg_check2 ) {	/*	񔻒肷Ȃ	*/
				n = 0;
				Sym[n++] = (uchar)dt;
				for( ;; ) {
					if( Sym_ll == Sym_la ) {
						Sym[1] = 0x00;
						Sym_la -= (n-1);
						return( SYM_OTHER );
					}
					Sym[n] = (uchar)(Sym_bf[Sym_la++]);
					if( Sym[n++] == '\'' ) {
						Sym[n] = 0x00;
						break;
					}
				}
				return( SYM_MSG );
			}
			/* 'x' */
			if( Sym_bf[Sym_la] && Sym_bf[Sym_la+1] == '\'' ) {
				sprintf( Sym, "%u", Sym_bf[Sym_la] );
				Sym_la+=2;
				return( SYM_VAL );
			}
			/* '\x' */
			if( Sym_bf[Sym_la] == '\\' &&
					Sym_bf[Sym_la+2] == '\'' ) {
				switch( Sym_bf[Sym_la+1] ) {
				case	'b':	/*	obNXy[X	*/
					sprintf( Sym, "%u", '\b' );	break;
				case	'f':	/*	tH[tB[h	*/
					sprintf( Sym, "%u", '\f' );	break;
				case	'a':	/*	x	*/
					sprintf( Sym, "%u", '\a' );	break;
				case	'r':
					sprintf( Sym, "%u", '\r' );	break;
				case	'n':
					sprintf( Sym, "%u", '\n' );	break;
				case	't':
					sprintf( Sym, "%u", '\t' );	break;
				case	'\'':
					sprintf( Sym, "%u", '\'' );	break;
				case	'\\':
					sprintf( Sym, "%u", '\\' );	break;
				default:
					Sym[0] = dt;
					Sym[1] = 0x00;
					return( SYM_OTHER );
				}
				Sym_la+=3;
				return( SYM_VAL );
			}
			Sym[0] = dt;
			Sym[1] = 0x00;
			return( SYM_OTHER );
		/*	Rg	*/
		case	';':
			for( ;; ) {
				if( Sym_ll == Sym_la ) {
					return( SYM_END );
				}
				if( Sym_bf[Sym_la++] == '\n' ) {
					break;
				}
			}
			return( SYM_LINEEND );/*	ȉRg	*/
		case	'=':
		case	'!':
			Sym[0] = (uchar)dt;
			if( Sym_bf[Sym_la] == '=' ) {
				Sym_la++;
				Sym[1] = '=';
				Sym[2] = 0x00;
			} else {
				Sym[1] = 0x00;
			}
			return( SYM_OTHER );
		case	'<':
			Sym[0] = (uchar)dt;
			if( Sym_bf[Sym_la] == '<' ) {
				Sym_la++;
				Sym[1] = '<';
				Sym[2] = 0x00;
			} else if( Sym_bf[Sym_la] == '=' ) {
				Sym_la++;
				Sym[1] = '=';
				Sym[2] = 0x00;
			} else {
				Sym[1] = 0x00;
			}
			return( SYM_OTHER );
		case	'>':
			Sym[0] = (uchar)dt;
			if( Sym_bf[Sym_la] == '>' ) {
				Sym_la++;
				Sym[1] = '>';
				Sym[2] = 0x00;
			} else if( Sym_bf[Sym_la] == '=' ) {
				Sym_la++;
				Sym[1] = '=';
				Sym[2] = 0x00;
			} else {
				Sym[1] = 0x00;
			}
			return( SYM_OTHER );
		case	'|':
			Sym[0] = (uchar)dt;
			if( Sym_bf[Sym_la] == '|' ) {
				Sym_la++;
				Sym[1] = '|';
				Sym[2] = 0x00;
			} else {
				Sym[1] = 0x00;
			}
			return( SYM_OTHER );
		case	'&':
			Sym[0] = (uchar)dt;
			if( Sym_bf[Sym_la] == '&' ) {
				Sym_la++;
				Sym[1] = '&';
				Sym[2] = 0x00;
			} else {
				Sym[1] = 0x00;
			}
			return( SYM_OTHER );
		case	'(':
			Sym[0] = dt;
			Sym[1] = 0x00;
			return( SYM_LPAR );
		case	')':
			Sym[0] = dt;
			Sym[1] = 0x00;
			return( SYM_RPAR );
		case	',':
			Sym[0] = dt;
			Sym[1] = 0x00;
			return( SYM_COMMA );
		case	'$':
			if( Sym_ll != Sym_la && isxdigit( Sym_bf[Sym_la] ) ) {
				/*	$xxx `16i	*/
				n = 0;
				Sym[n++] = Sym_bf[Sym_la++];
				for( ;; ) {
					if( Sym_bf[Sym_la] == '_' ) {
						Sym_la++;
						continue;
					}
					if( !isxdigit( Sym_bf[Sym_la] ) ) {
						break;
					}
					Sym[n++] = Sym_bf[Sym_la++];
				}
				Sym[n] = 0x00;
				if( strlen( Sym ) > 8 ) {
					strcpy( Sym2, Sym );
					return( SYM_STR );
				}
				sscanf( Sym, "%lx", &tmp_dt );
				sprintf( Sym, "%lu", tmp_dt );
				return( SYM_VAL );
			}
			Sym[0] = dt;
			Sym[1] = 0x00;
			/*	AhXp SYM_STR 	*/
			strcpy( Sym2, Sym );
			return( SYM_STR );
		case	'#':
			/*	#0 - #9 p Sym_ncd ݒ	*/
			if( Sym_ll != Sym_la ) {
				Sym_ncd = (int)(Sym_bf[Sym_la]);
			}
			Sym[0] = dt;
			Sym[1] = 0x00;
			return( SYM_OTHER );
		default:
			/*֐AϐAxA\ꓙ*/
/* 1998/10/04		if( isalpha( dt ) || (dt == '_') ) {	*/
			if( isalpha( dt ) || (dt == '_') || (dt == '@') ) {
				Sym_adr = Sym_la-1;			/*	擪oCgڂ̕񂩁H	*/
				n = 0;
				Sym[n] = (uchar)tolower(dt);
				Sym2[n++] = (uchar)dt;

				/* 2000/08/03 @string`ւ̑Ή */
				if( Sym_str_mode && dt == '@' ) {	/* 0:normal,1:@string@SYM_OTHERƂĈ */
					Sym[1] = 0x00;
					return( SYM_OTHER );
				}
				/* 2000/08/03 H'xx `,D'xx`,Q'xx `,B'xx `̐lΉ */
				if( Sym_bf[Sym_la] == '\'' ) {
					switch( Sym[0] ) {
					case	'h':	/* H'xx `16i */
						if( !isxdigit(Sym_bf[Sym_la+1]) ) {
							break;
						}
						Sym_la++;
						n = 0;
						Sym[n++] = Sym_bf[Sym_la++];
						for( ;; ) {
							if( Sym_bf[Sym_la] == '_' ) {
								Sym_la++;
								continue;
							}
							if( !isxdigit( Sym_bf[Sym_la] ) ) {
								break;
							}
							Sym[n++] = Sym_bf[Sym_la++];
						}
						Sym[n] = 0x00;
						sscanf( Sym, "%lx", &tmp_dt );
						sprintf( Sym, "%lu", tmp_dt );
						return( SYM_VAL );
					case	'd':	/* D'xx `10i */
						if( !isdigit(Sym_bf[Sym_la+1]) ) {
							break;
						}
						Sym_la++;
						n = 0;
						Sym[n++] = Sym_bf[Sym_la++];
						for( ;; ) {
							if( Sym_bf[Sym_la] == '_' ) {
								Sym_la++;
								continue;
							}
							if( !isdigit( Sym_bf[Sym_la] ) ) {
								break;
							}
							Sym[n++] = Sym_bf[Sym_la++];
						}
						Sym[n] = 0x00;
						return( SYM_VAL );
					case	'q':	/* Q'xx `8i */
						if( strchr( "01234567", Sym_bf[Sym_la+1] ) == NULL ) {
							break;
						}
						Sym_la++;
						n = 0;
						Sym[n++] = Sym_bf[Sym_la++];
						for( ;; ) {
							if( Sym_bf[Sym_la] == '_' ) {
								Sym_la++;
								continue;
							}
							if( strchr( "01234567", Sym_bf[Sym_la+1] ) == NULL ) {
								break;
							}
							Sym[n++] = Sym_bf[Sym_la++];
						}
						Sym[n] = 0x00;
						if( oct_to_dec( Sym, &tmp_dt ) == -1 ) {
							Sym_la--;
							strcpy( Sym2, Sym );
							return( SYM_STR );
						}
						sprintf( Sym, "%lu", tmp_dt );
						return( SYM_VAL );
					case	'b':	/* B'xx `2i */
						if( Sym_bf[Sym_la+1] != '0' && Sym_bf[Sym_la+1] != '1' ) {
							break;
						}
						Sym_la++;
						n = 0;
						Sym[n++] = Sym_bf[Sym_la++];
						for( ;; ) {
							if( Sym_bf[Sym_la] == '_' ) {
								Sym_la++;
								continue;
							}
							if( Sym_bf[Sym_la] != '0' && Sym_bf[Sym_la] != '1' ) {
								break;
							}
							Sym[n++] = Sym_bf[Sym_la++];
						}
						Sym[n] = 0x00;
						if( bin_to_dec( Sym, &tmp_dt ) == -1 ) {
							Sym_la--;
							strcpy( Sym2, Sym );
							return( SYM_STR );
						}
						sprintf( Sym, "%lu", tmp_dt );
						return( SYM_VAL );
					default:
						break;
					}
				}

				while( 1 ) {
					if( Sym_ll == Sym_la ) {
						Sym[n] = 0x00;
						Sym2[n] = 0x00;
						return( SYM_STR );
					}
					dt = (int)(Sym_bf[Sym_la++]);
/* 1998/10/04		if( !isalnum( dt ) && (dt != '_' ) ) {	*/
/*					if( !isalnum( dt ) && (dt != '_' ) && (dt != '@') ) { */
/* 2000/10/09 dotƔf悤ɏC */
					if( !isalnum( dt ) && strchr("_@.",dt) == NULL ) {
						Sym_la--;
						Sym[n] = 0x00;
						Sym2[n] = 0x00;
						break;
					}
					Sym[n] = (uchar)tolower(dt);
					Sym2[n++] = (uchar)dt;
				}
				Sym_ncd = dt;				/*	񒼌̃R[h	*/
				return( SYM_STR );
			} else if( isdigit( dt ) ) {	/*	l	*/
				n = 0;
				Sym[n++] = (uchar)dt;
				if( Sym_ll == Sym_la ) {
					Sym[n] = 0x00;
					return( SYM_VAL );
				}
				for( ;; ) {
					if( (Sym[n] = Sym_bf[Sym_la++]) == '_' ) {
						continue;
					}
					/* 2000/04/24 */
					if( n == 1 && Sym[0] == '0' && tolower(Sym[1]) == 'x' ) {
						n++;
						continue;
					}
					if( !isxdigit( Sym[n] ) ) {
						switch( toupper(Sym[n]) ) {
						case	'H':
							Sym[n] = 0x00;
							if( strlen( Sym ) > 8 ) {
								Sym_la--;
								strcpy( Sym2, Sym );
								return( SYM_STR );
							}
							sscanf( Sym, "%lx", &tmp_dt );
							sprintf( Sym, "%lu", tmp_dt );
							break;
						case	'O':
							Sym[n] = 0x00;
							/*	Wil	*/
							if( oct_to_dec( Sym, &tmp_dt ) == -1 ) {
								Sym_la--;
								strcpy( Sym2, Sym );
								return( SYM_STR );
							}
							sprintf( Sym, "%lu", tmp_dt );
							break;
						default:
							Sym[n] = 0x00;
							Sym_la--;
							/* 2000/04/24 */
							if( Sym[0] == '0' && tolower(Sym[1]) == 'x' ) {
								sscanf( &Sym[2], "%lx", &tmp_dt );
								sprintf( Sym, "%lu", tmp_dt );
								strcpy( Sym2, Sym );
							} else if( toupper(Sym[n-1]) == 'B' ) {
								Sym[n-1] = 0x00;
								/*	Qil	*/
								if( bin_to_dec( Sym, &tmp_dt ) == -1 ) {
									Sym_la--;
									strcpy( Sym2, Sym );
									return( SYM_STR );
								}
								sprintf( Sym, "%lu", tmp_dt );
							} else {
								for( n=0; n<(int)strlen( Sym ); n++ ) {
									if( !isdigit( Sym[n] ) ) {
										strcpy( Sym2, Sym );
										return( SYM_STR );
									}
								}
							}
							break;
						}
						return( SYM_VAL );
					}
					n++;
				}
			} else {

				/* 2000/04/24 .include 𕶎Ɣ肷悤ɏC */
				if( (dt == '.') &&
						(isalpha(Sym_bf[Sym_la]) || (Sym_bf[Sym_la] == '_') || (Sym_bf[Sym_la] == '@')) ) {
					Sym_adr = Sym_la-1;			/*	擪oCgڂ̕񂩁H	*/
					n = 0;
					Sym[n] = (uchar)tolower(dt);
					Sym2[n++] = (uchar)dt;
					while( 1 ) {
						if( Sym_ll == Sym_la ) {
							Sym[n] = 0x00;
							Sym2[n] = 0x00;
							return( SYM_STR );
						}
						dt = (int)(Sym_bf[Sym_la++]);
/* 2000/10/09 dotƔf悤ɏC */
/*						if( !isalnum( dt ) && (dt != '_' ) && (dt != '@') ) { */
						if( !isalnum( dt ) && strchr("_@.",dt) == NULL ) {
							Sym_la--;
							Sym[n] = 0x00;
							Sym2[n] = 0x00;
							break;
						}
						Sym[n] = (uchar)tolower(dt);
						Sym2[n++] = (uchar)dt;
					}
					Sym_ncd = dt;				/*	񒼌̃R[h	*/
					return( SYM_STR );
				}

				Sym[0] = (uchar)dt;
				Sym[1] = 0x00;
				return( SYM_OTHER );
			}
		}
	}
}
