/*
  AASM o̓t@Ce
D          f[^GAֈڍs
PCxxx xx   GAw(CSEG)AxAAhX
PDxxx xx   GAw(DSEG)AxAAhX
EC xxx     R[hGAIƍŏIAhX
ED xxx     f[^GAIƍŏIAhX
;C Rg
:xxx       HEXf[^
RCB        Ĕzu(CSEG,DEFB)
RCW        Ĕzu(CSEG,DEFW)
RCD        Ĕzu(CSEG,DEFD)
RDB        Ĕzu(DSEG,DEFB)
RDW        Ĕzu(DSEG,DEFW)
RDD        Ĕzu(DSEG,DEFD)
*/

/*
  Cuo̓t@Ce
S           Jn
C xxx      R[hGA̒(16i)
D xxx      f[^GA̒(16i)
PCxxx xx   GAw(CSEG)AxAAhX
PDxxx xx   GAw(DSEG)AxAAhX
;C Rg
RCB        Ĕzu(CSEG,DEFB)
RCW        Ĕzu(CSEG,DEFW)
RCD        Ĕzu(CSEG,DEFD)
RDB        Ĕzu(DSEG,DEFB)
RDW        Ĕzu(DSEG,DEFW)
RDD        Ĕzu(DSEG,DEFD)
D          f[^GAֈڍs
:xxx       HEXf[^
E          I
*/

#include	<stdio.h>
#include	<malloc.h>
#include	<string.h>

static	char	*Copyright =
	"AASM library tool Version 1.10  Copyright (C) 1994,2000 T.SAGAE";

#define		CSEG	0
#define		DSEG	1
static	unsigned	long	Seg_end[2];

#ifdef	PROTOTYPE1
int lib_check(char *,int);
void set_adr(int,unsigned long);
int lib_delete(char *,char *,int);
int lib_append(char *,char *);
void help(void);
int main(int,char **);
extern void bsrh_init(int *,long *);
extern int regword_set(char *);
extern int regword_srh(char *);
#else
int lib_check();
void set_adr();
int lib_delete();
int lib_append();
void help();
int main();
extern void bsrh_init();
extern int regword_set();
extern int regword_srh();
#endif

/*	Cu̎擾A\	*/
#ifdef	PROTOTYPE1
int		lib_check( char *name, int mode )
#else
int		lib_check( name, mode )
char	*name;
int		mode;
#endif
{
	FILE	*fp;
	char	bf[2][100];
	unsigned	long	adr;

	if( (fp=fopen( name, "r" )) == NULL ) {
		/*	VK쐬	*/
		if( mode == 1 ) {
			printf( "Library not found [%s]!!!\n", name );
		}
		return( 0 );
	}
	if( mode == 1 ) {
		printf( "LIBRARY NAME [%s]\n", name );
	}
	while( fgets( bf[0], 100, fp ) != NULL ) {
		if( strncmp( bf[0], "C ", 2 ) == 0 ) {
			if( mode == 1 ) {
				sscanf( bf[0]+2, "%lx", &adr );
				printf( "\nCODE %3lX    ", adr );
			}
			continue;
		} else if( strncmp( bf[0], "D ", 2 ) == 0 ) {
			if( mode == 1 ) {
				sscanf( bf[0]+2, "%lx", &adr );
				printf( "DATA %3lX\n", adr );
			}
			continue;
		} else if( strncmp( bf[0], ";C ", 3 ) == 0 ) {
			if( mode == 1 ) {
				printf( " ; %s", bf[0]+3 );
			}
			continue;
		} else if( *bf[0] != 'P' ) {
			/*	public 錾𔲂o	*/
			continue;
		}
		sscanf( &bf[0][2], "%s", bf[1] );
		if( regword_srh( bf[1] ) == 0 ) {
			printf( "Qd`Ă܂ [%s]\n", bf[1] ); 
			fclose( fp );
			return( -1 );
		}
		if( mode == 1 ) {
			printf( " > %s ", (bf[0][1] == 'C' ? "CODE" : "DATA") );
			printf( "%s", bf[0]+2 );
		}
		if( regword_set( bf[1] ) != 0 ) {
			printf( "Cuo^Ɏs܂ [%s]\n", bf[1] ); 
			fclose( fp );
			return( -1 );
		}
	}
	fclose( fp );
	return( 0 );
}

/*	őAhXi[	*/
#ifdef	PROTOTYPE1
void	set_adr( int seg, unsigned long adr )
#else
void	set_adr( seg, adr )
int		seg;
unsigned	long	adr;
#endif
{
	if( Seg_end[seg] < adr ) {
		Seg_end[seg] = adr;
	}
}

/*	Cu폜	*/
#ifdef	PROTOTYPE1
int		lib_delete( char *lib_file, char *name, int sw )
#else
int		lib_delete( lib_file, name, sw )
char	*lib_file, *name;
int		sw;	/*	0:t@C疼O擾A1:O	*/
#endif
{
	FILE	*fp, *tp;
	char	*func, bf[100], bf2[100], del[100];
	long	file_adr;
	int		flg;

	if( sw == 0 ) {	/*	0:t@C疼O擾A1:O	*/
		if( (fp = fopen( name, "r" )) == NULL ) {
			printf( "File open error [%s]!!!\n", name );
			return( -1 );
		}
		*del = 0x00;
		while( fgets( bf, 100, fp ) != NULL ) {
			if( *bf == 'P' ) {
				sscanf( bf+2, "%s", del );
				break;
			}
		}
		fclose( fp );
		if( *del == 0x00 ) {
			printf( "Not found name [%s]!!!\n", name );
			return( 0 );
		}
		func = del;
	} else {
		func = name;
	}
	if( (fp = fopen( lib_file, "r" )) == NULL ) {
		printf( "File open error [%s]!!!\n", lib_file );
		return( -1 );
	}
	flg = 0;
	while( fgets( bf, 100, fp ) != NULL ) {
		if( *bf == 'S' ) {
			file_adr = ftell( fp );
		} else if( *bf == 'P' ) {
			sscanf( bf+2, "%s", bf2 );
			if( strcmp( bf2, func ) == 0 ) {
				flg = 1;
				break;
			}
		}
	}
	if( flg == 0 ) {
		printf( "Not found name [%s]!!!\n", func );
		return( 0 );
	}
	fseek( fp, file_adr, 0 );
	printf( "Delete function\n" );
	while( fgets( bf, 100, fp ) != NULL ) {
		if( *bf == 'P' ) {
			printf( " > %s ", (bf[1] == 'C' ? "CODE" : "DATA") );
			printf( "%s", bf+2 );
		} else if( *bf == 'E' ) {
			break;
		}
	}
	if( (tp=tmpfile()) == NULL ) {
		printf( "e|t@CI[vG[\n" );
		fclose( fp );
		return( -1 );
	}
	rewind( fp );
	while( fgets( bf, 100, fp ) != NULL ) {
		if( file_adr == ftell( fp ) ) {
			while( fgets( bf, 100, fp ) != NULL ) {
				if( *bf == 'E' ) {
					break;
				}
			}
		} else {
			fprintf( tp, bf );
		}
	}
	fclose( fp );
	if( (fp = fopen( lib_file, "w" )) == NULL ) {
		printf( "File open error [%s]!!!\n", lib_file );
		return( -1 );
	}
	rewind( tp );
	while( fgets( bf, 100, tp ) != NULL ) {
		fprintf( fp, bf );
	}
	fclose( fp );
	fclose( tp );
	printf( "Delete end\n\n" );
	return( 0 );
}

/*	Cuǉ	*/
#ifdef	PROTOTYPE1
int		lib_append( char *lib_file, char *name )
#else
int		lib_append( lib_file, name )
char	*lib_file;
char	*name;
#endif
{
	FILE	*fp, *fpw;
	char	bf[3][100], temp[5];
	/*	ꂼ̊Jn^IAhX	*/
	unsigned	long	adr;
	int		lib_cnt;
	int		n;
	int		seg;

	if( (fp = fopen( name, "r" )) == NULL ) {
		printf( "File open error [%s]!!!\n", name );
		return( -1 );
	}
	Seg_end[CSEG] = Seg_end[DSEG] = 0L;
	lib_cnt = 0;
	seg = CSEG;
	while( fgets( bf[0], 100, fp ) != NULL ) {
		if( *bf[0] == 'P' ) {
			sscanf( &bf[0][2], "%s %lx", bf[1], &adr );
			if( bf[0][1] == 'C' ) {
				set_adr( CSEG, adr );
			} else {
				set_adr( DSEG, adr );
			}
			if( regword_srh( bf[1] ) == 0 ) {
				printf( "Qdo^ł [%s]\n", bf[1] );
				fclose( fp );
				return( -1 );
			}
			lib_cnt++;
		} else if( strncmp( bf[0], "EC", 2 ) == 0 ) {
			sscanf( bf[0], "%*s %lx", &adr );
			set_adr( CSEG, adr );
		} else if( strncmp( bf[0], "ED", 2 ) == 0 ) {
			sscanf( bf[0], "%*s %lx", &adr );
			set_adr( DSEG, adr );
		} else if( *bf[0] == 'D' ) {
			seg = DSEG;
		} else if( *bf[0] == ':' ) {
			/*	f[^ŏAhXZo	*/
			if( strncmp( bf[0]+7, "00", 2 ) == 0 ) {
				strncpy( temp, bf[0]+3, 4 );
				temp[4] = 0x00;
				sscanf( temp, "%lx", &adr );
				set_adr( seg, adr );
			}
		}
	}
	if( lib_cnt == 0 ) {
		printf( "library information not found!!!\n" );
	}
	printf( "Append function\n" );
	if( (fpw=fopen( lib_file, "a" )) == NULL ) {
		fclose( fp );
		printf( "File open error [%s]!!!\n", lib_file );
		return( -1 );
	}
	fprintf( fpw, "S\n" );
	fprintf( fpw, "C %lX\n", Seg_end[CSEG] );
	fprintf( fpw, "D %lX\n", Seg_end[DSEG] );
	rewind( fp );
	while( fgets( bf[0], 100, fp ) != NULL ) {
		if( *bf[0] != 'E' ) {
			if( strncmp( bf[0], ":00000001FF", 11 ) == 0 ) {
				fprintf( fpw, "E\n" );
			} else {
				if( *bf[0] == 'P' ) {
					printf( " > %s ", (bf[0][1] == 'C' ? "CODE" : "DATA") );
					printf( "%s", bf[0]+2 );
				}
				fprintf( fpw, "%s", bf[0] );
			}
		}
	}
	fclose( fp );
	fclose( fpw );
	printf( "Append end\n\n" );
	return( 0 );
}

#ifdef	PROTOTYPE1
void	help( void )
#else
void	help()
#endif
{
	printf( " >alib lib_name [options]\n" );
	printf( "  [options]\n" );
	printf( "     +xxx   : append library(xxx:filename)\n" );
	printf( "     -xxx   : delete library(xxx:function)\n" );
	printf( "    -+xxx   : update library(xxx:filename)\n" );
	printf( "    nothing : display library\n" );
}

#ifdef	PROTOTYPE1
int		main( int ar, char *av[] )
#else
int		main( ar, av )
int		ar;
char	*av[];
#endif
{
	int		n;

	printf( "%s\n\n", Copyright );
	if( ar < 2 ) {
		help();
		return( 1 );
	} else if( ar == 2 ) {
		/*	e̕\	*/
		if( lib_check( av[1], 1 ) == -1 ) {
			return( 1 );
		}
		return( 0 );
	}
	for( n=1; n<ar; n++ ) {
		switch( n ) {
		case	1:
			if( lib_check( av[n], 0 ) == -1 ) {
				return( 1 );
			}
			break;
		default:
			switch( *av[n] ) {
			case	'+':	/*	ǉ	*/
				if( lib_append( av[1], &av[n][1] ) == -1 ) {
					return( 1 );
				}
				break;
			case	'-':
				if( *(av[n]+1) == '+' ) {	/*	XV	*/
					/*	폜	*/
					if( lib_delete( av[1], &av[n][2], 0 ) == -1 ) {
						return( 1 );
					}
					/*	do^mFpe[u	*/
					bsrh_init( NULL, NULL );
					/*	ǉ	*/
					if( lib_append( av[1], &av[n][2] ) == -1 ) {
						return( 1 );
					}
				} else {	/*	폜	*/
					if( lib_delete( av[1], &av[n][1], 1 ) == -1 ) {
						return( 1 );
					}
				}
				break;
			default:
				help();
				return( 1 );
			}
			break;
		}
	}
	return( 0 );
}
