#include	<stdio.h>
#include	<string.h>
#include	<ctype.h>
#include	<fcntl.h>

static	char	*Copyright =
	"HEX file Tool Version 3.10 Copyright (C) 1994,2000 T.SAGAE";

static	unsigned	int	Fill_code = 0xff;	

#define	MAX_TABLE	200

struct	_finf {
	long	fad;	/*	t@C̈ʒu(ftell)	*/
	long	flen;	/*	Õf[^	*/
	long	had;	/*	f[^̃AhX	*/
}	finf[MAX_TABLE+1];

#define		D_MOTO	1
#define		D_INTEL	2
#define		D_BIN	3

#ifdef	PROTOTYPE1
int offset_change(char *,long,char *);
int data_output(int,unsigned long,unsigned char,FILE * );
int fmt_conv(int,int,char *,char *);
int format_conv(char *,char *);
void help(void);
int main(int,char **);
extern void ihex(int,unsigned long,unsigned char,FILE *);
extern void ihex_out(int,FILE *);
extern void ihex_end(FILE *);
extern int mhex(int,unsigned long,unsigned char,FILE *);
extern void mhex_out(int,FILE *);
extern void mhex_end(FILE *);
#else
int offset_change();
int data_output();
int fmt_conv();
int format_conv();
void help();
int main();
extern void ihex();
extern void ihex_out();
extern void ihex_end();
extern int mhex();
extern void mhex_out();
extern void mhex_end();
#endif

#ifdef	PROTOTYPE1
int	offset_change( char *name, long adj_offset, char *outfile )
#else
int	offset_change( name, adj_offset, outfile )
char	*name;
long	adj_offset;
char	*outfile;
#endif
{
	FILE	*fpr, *fpw;
	char	buff[200], temp[10];
	int		dat_len, n, dat, mode;
	long	adr, seg;
	char	*p;

	if( (fpr=fopen(name,"r")) == NULL ) {
		printf( "File open error!!!\n" );
		return(-1);
	}
	fpw = NULL;
	if( outfile != NULL ) {
		if( (fpw=fopen(outfile,"w")) == NULL ) {
			printf( "File open error!!!\n" );
			fclose( fpr );
			return(-1);
		}
	}
	seg = 0L;
	mode = 0;
	while( fgets( buff, 200, fpr ) != NULL ) {
		if( strlen(buff) < 2 ) {
			continue;
		}
		if( *buff == ':' ) {
			mode = D_INTEL;
			if( strlen( buff ) > 9 ) {
				if( strncmp( &buff[7], "00", 2 ) == 0 ) {		/*	data	*/
					strncpy( temp, &buff[3], 4 );
					temp[4] = 0x00;
					sscanf( temp, "%lx", &adr );
					adr += seg;
					strncpy( temp, &buff[1], 2 );
					temp[2] = 0x00;
					sscanf( temp, "%x", &dat_len );
					for( n=0; n<dat_len; n++ ) {
						strncpy( temp, &buff[n*2+9], 2 );
						sscanf( temp, "%x", &dat );
						ihex(0,adr+adj_offset+(long)n,(unsigned char)dat,fpw);
					}
				} else if( strncmp( &buff[7], "01", 2 ) == 0 ) {/*	end		*/
					break;
				} else if( strncmp( &buff[7], "02", 2 ) == 0 ) {/*	segment	*/
					strncpy( temp, &buff[9], 4 );
					temp[4] = 0x00;
					sscanf( temp, "%lx", &seg );
					seg <<= 4L;
				} else if( strncmp( &buff[7], "04", 2 ) == 0 ) {/*	segment	*/
					strncpy( temp, &buff[9], 4 );
					temp[4] = 0x00;
					sscanf( temp, "%lx", &seg );
					seg <<= 16L;
				} else {
					printf( "ERROR %s\n", buff );
					if( fpw != NULL )	fclose( fpw );
					fclose( fpr );
					return( -1 );
				}
			} else {
				if( fpw != NULL )	fclose( fpw );
				fclose( fpr );
				return( -1 );
			}
		} else if( *buff == 'S' ) {
			mode = D_MOTO;
			if( strlen( buff ) > 8 ) {
				if( strchr( "123", *(buff+1) ) != NULL ) {	/*	data	*/
					strncpy( temp, &buff[2], 2 );
					temp[2] = 0x00;
					sscanf( temp, "%x", &dat_len );
					if( *(buff+1) == '1' ) {
						dat_len -= 3;
						p = buff+8;
						strncpy( temp, &buff[4], 4 );
						temp[4] = 0x00;
						sscanf( temp, "%lx", &adr );
					} else if( *(buff+1) == '2' ) {
						dat_len -= 4;
						p = buff+10;
						strncpy( temp, &buff[4], 6 );
						temp[6] = 0x00;
						sscanf( temp, "%lx", &adr );
					} else {
						dat_len -= 5;
						p = buff+12;
						strncpy( temp, &buff[4], 8 );
						temp[8] = 0x00;
						sscanf( temp, "%lx", &adr );
					}
					temp[2] = 0x00;
					for( n=0; n<dat_len; n++ ) {
						strncpy( temp, (p+n*2), 2 );
						sscanf( temp, "%x", &dat );
						if( mhex(0,adr+adj_offset+(long)n,
								(unsigned char)dat, fpw ) == -1 ) {
							if( fpw != NULL )	fclose( fpw );
							fclose( fpr );
							return( -1 );
						}
					}
				} else if( *(buff+1) == '9' ) {	/*	end		*/
					break;
				} else if( *(buff+1) == '0' ) {	/*	header	*/
					;	/*	ł̓wb_[͖	*/
				} else {
					printf( "ERROR %s\n", buff );
					if( fpw != NULL )	fclose( fpw );
					fclose( fpr );
					return( -1 );
				}
			} else {
				if( fpw != NULL )	fclose( fpw );
				fclose( fpr );
				return( -1 );
			}
		}
	}
	switch( mode ) {
	case	D_INTEL:
		ihex_out( 0, fpw );
		ihex_end( fpw );
		break;
	case	D_MOTO:
		mhex_out( 0, fpw );
		mhex_end( fpw );
		break;
	default:
		if( fpw != NULL )	fclose( fpw );
		fclose( fpr );
		return( -1 );
	}
	if( fpw != NULL )	fclose( fpw );
	fclose( fpr );
	return( 0 );
}

#ifdef	PROTOTYPE1
int		data_output( int out, unsigned long adr, unsigned char d, FILE *fp )
#else
int		data_output( out, adr, d, fp )
int		out;
unsigned	long	adr;
unsigned	char	d;
FILE	*fp;
#endif
{
	static	unsigned	long	old_adr = 0;
	int		n;

	switch( out ) {
	case	D_MOTO:
		if( mhex( 0, adr, d, fp ) == -1 ) {
			return( -1 );
		}
		break;
	case	D_INTEL:
		ihex( 0, adr, d, fp );
		break;
	case	D_BIN:
		if( old_adr < adr ) {
			for( n=0; n<(adr-old_adr); n++ ) {
				fputc( Fill_code, fp );
			}
			fputc( d, fp );
			old_adr = adr + 1L;
		} else if( old_adr == adr ) {
			fputc( d, fp );
			old_adr = adr + 1L;
		} else {
			printf( "AhXɂȂĂ܂\n" );
			return( -1 );
		}
		break;
	}
	return( 0 );
}

#ifdef	PROTOTYPE1
int		fmt_conv( int in, int out, char *infile, char *outfile )
#else
int		fmt_conv( in, out, infile, outfile )
int		in, out;
char	*infile, *outfile;
#endif
{
	FILE	*fpr, *fpw;
	int		d, n, type, data_len;
	char	bf[256], bf2[10], *mdr, *mdw;
	unsigned	long	adr, seg;
	char	*p;

	if( in == D_BIN ) {
		mdr = "rb";
	} else {
		mdr = "r";
	}
	if( out == D_BIN ) {
		mdw = "wb";
	} else {
		mdw = "w";
	}
	if( (fpr=fopen( infile, mdr )) == NULL ) {
		printf( "File open error [%s]!!!\n", infile );
		return( -1 );
	}
	fpw = NULL;
	if( outfile != NULL ) {
		if( (fpw=fopen( outfile, mdw )) == NULL ) {
			printf( "File open error [%s]!!!\n", outfile );
			fclose( fpr );
			return( -1 );
		}
	}
	seg = 0L;
	adr = 0L;
	if( in == D_BIN ) {
		/*	oCit@C̓͂Ȃ	*/
		for( ;; ) {
			if( (d = fgetc( fpr )) < 0 ) {
				break;
			}
			if( data_output( out, adr, d, fpw ) == -1 ) {
				fclose( fpr );
				if( fpw != NULL ) {
					fclose( fpw );
				}
				return( -1 );
			}
			adr++;
		}
	} else {
		/*	۰ S,Intel HEX ̓͂Ȃ	*/
		while( fgets( bf, 256, fpr ) != NULL ) {
			switch( in ) {
			case	D_MOTO:
				if( *bf != 'S' ) {
					printf( "۰ S ̫ϯ ł͗L܂\n" );
					fclose( fpr );
					if( fpw != NULL ) {
						fclose( fpw );
					}
					return( -1 );
				}
				if( *(bf+1) == '0' ) {
					;	/*	wb_[͎gȂ	*/
				} else if( strchr( "123", *(bf+1) ) != NULL ) {
					bf2[2] = 0x00;
					strncpy( bf2, (bf+2), 2 );
					sscanf( bf2, "%x", &data_len );
					if( *(bf+1) == '1' ) {
						/* 2byte AhX */
						data_len-=3;	/*	check sum,address 	*/
						p = bf+8;	/* f[^̐擪w悤ɂ */
						bf2[4] = 0x00;
						strncpy( bf2, (bf+4), 4 );
						sscanf( bf2, "%lx", &adr );
					} else if( *(bf+1) == '2' ) {
						/* 3byte AhX */
						data_len-=4;	/*	check sum,address 	*/
						p = bf+10;	/* f[^̐擪w悤ɂ */
						bf2[6] = 0x00;
						strncpy( bf2, (bf+4), 6 );
						sscanf( bf2, "%lx", &adr );
					} else {
						/* 4byte AhX */
						data_len-=5;	/*	check sum,address 	*/
						p = bf+12;	/* f[^̐擪w悤ɂ */
						bf2[8] = 0x00;
						strncpy( bf2, (bf+4), 8 );
						sscanf( bf2, "%lx", &adr );
					}
					/*	f[^	*/
					bf2[2] = 0x00;
					for( n=0; n<data_len; n++ ) {
						strncpy( bf2, (p+n*2), 2 );
						sscanf( bf2, "%x", &d );
						if( data_output( out, adr+n, d, fpw ) == -1 ) {
							fclose( fpr );
							if( fpw != NULL ) {
								fclose( fpw );
							}
							return( -1 );
						}
					}
				} else if( *(bf+1) == '9' ) {
					;	/*	I͎gȂ	*/
				}
				break;
			case	D_INTEL:
				if( *bf != ':' ) {
					printf( "Intel HEX ̫ϯ ł͗L܂\n" );
					fclose( fpr );
					if( fpw != NULL ) {
						fclose( fpw );
					}
					return( -1 );
				}
				if( strncmp( (bf+7), "00", 2 ) == 0 ) {
					/*	f[^	*/
					bf2[4] = 0x00;
					strncpy( bf2, (bf+3), 4 );
					sscanf( bf2, "%lx", &adr );
					adr += seg;
					bf2[2] = 0x00;
					strncpy( bf2, (bf+1), 2 );
					sscanf( bf2, "%x", &data_len );
					for( n=0; n<data_len; n++ ) {
						strncpy( bf2, (bf+n*2+9), 2 );
						sscanf( bf2, "%x", &d );
						if( data_output( out, adr+n, d, fpw ) == -1 ) {
							fclose( fpr );
							if( fpw != NULL ) {
								fclose( fpw );
							}
							return( -1 );
						}
					}
				} else if( strncmp( (bf+7), "01", 2 ) == 0 ) {
					;	/*	I͎gȂ	*/
				} else if( strncmp( (bf+7), "02", 2 ) == 0 ) {
					/*	gAhXw	*/
					bf2[4] = 0x00;
					strncpy( bf2, (bf+9), 4 );
					sscanf( bf2, "%lx", &seg );
					seg <<= 4L;
				} else if( strncmp( (bf+7), "04", 2 ) == 0 ) {
					/*	gAhXw	*/
					bf2[4] = 0x00;
					strncpy( bf2, (bf+9), 4 );
					sscanf( bf2, "%lx", &seg );
					seg <<= 16L;
				}
				break;
			}
		}
	}
	switch( out ) {
	case	D_MOTO:
		mhex_out( 0, fpw );
		mhex_end( fpw );
		break;
	case	D_INTEL:
		ihex_out( 0, fpw );
		ihex_end( fpw );
		break;
	case	D_BIN:
		break;
	}
	if( fpw != NULL ) {
		fclose( fpw );
	}
	fclose( fpr );
	return( 0 );
}

#ifdef	PROTOTYPE1
int		format_conv( char *infile, char *outfile )
#else
int		format_conv( infile, outfile )
char	*infile, *outfile;
#endif
{
	int		mode, flg, m, n, dt, max_loop, len;
	FILE	*fpr, *fpw;
	char	bf1[100], bf2[20];
	long	fadr, adr, seg, out_len;
	char	*p;

	if( (fpr=fopen( infile, "r" )) == NULL ) {
		printf( "File open error [%s]!!!\n", infile );
		return( -1 );
	}
	fpw = NULL;
	if( outfile != NULL ) {
		if( (fpw=fopen( outfile, "w" )) == NULL ) {
			printf( "File open error [%s]!!!\n", outfile );
			return( -1 );
		}
	}
	max_loop = 0;
	seg = 0L;
	mode = 0;
	for( ;; ) {
		fadr = ftell( fpr );
		if( fgets( bf1, 100, fpr ) == NULL ) {
			break;
		}
		switch( mode ) {
		case	0:
			switch( *bf1 ) {
			case	'S':
				mode = D_MOTO;
				break;
			case	':':
				mode = D_INTEL;
				break;
			defult:
				break;
			}
			break;
		default:
			break;
		}
		if( mode == 0 ) {
			continue;
		}
		switch( mode ) {
		case	D_MOTO:
			if( strchr( "123", *(bf1+1) ) != NULL ) {	/*	data	*/
				strncpy( bf2, &bf1[2], 2 );
				bf2[2] = 0x00;
				sscanf( bf2, "%x", &len );
				if( *(bf1+1) == '1' ) {
					/* 2byte AhX */
					len -= 3;	/*	f[^̒ɂ	*/
					p = bf1+8;	/* f[^̐擪w悤ɂ */
					bf2[4] = 0x00;
					strncpy( bf2, (bf1+4), 4 );
					sscanf( bf2, "%lx", &adr );
				} else if( *(bf1+1) == '2' ) {
					/* 3byte AhX */
					len -= 4;	/*	f[^̒ɂ	*/
					p = bf1+10;	/* f[^̐擪w悤ɂ */
					bf2[6] = 0x00;
					strncpy( bf2, (bf1+4), 6 );
					sscanf( bf2, "%lx", &adr );
				} else {
					/* 4byte AhX */
					len -= 5;	/*	f[^̒ɂ	*/
					p = bf1+12;	/* f[^̐擪w悤ɂ */
					bf2[8] = 0x00;
					strncpy( bf2, (bf1+4), 8 );
					sscanf( bf2, "%lx", &adr );
				}
				if( max_loop == 0 ) {
					finf[max_loop].fad = fadr;
					finf[max_loop].flen = len;
					finf[max_loop].had = adr;
					max_loop++;
				} else if( (finf[max_loop-1].had + finf[max_loop-1].flen) == adr ) {
					finf[max_loop-1].flen += len;
				} else {
					if( max_loop == MAX_TABLE ) {
						printf( "Table over flow\n" );
						fclose( fpr );
						if( fpw != NULL ) {
							fclose( fpw );
						}
						return( -1 );
					}
					finf[max_loop].fad = fadr;
					finf[max_loop].flen = len;
					finf[max_loop].had = adr;
					max_loop++;
				}
			} else if( *(bf1+1) == '9' ) {	/*	end		*/
				;
			} else if( *(bf1+1) == '0' ) {	/*	header	*/
				;	/*	ł̓wb_[͖	*/
			}
			break;
		case	D_INTEL:
			if( strncmp( bf1+7, "00", 2 ) == 0 ) {
				/*	f[^	*/
				strncpy( bf2, bf1 + 1, 2 );
				bf2[2] = 0x00;
				sscanf( bf2, "%x", &len );		/*	f[^擾	*/
				strncpy( bf2, bf1 + 3, 4 );
				bf2[4] = 0x00;
				sscanf( bf2, "%lx", &adr );		/*	f[^JnAhX擾	*/
				if( max_loop == 0 ) {
					finf[max_loop].fad = fadr;
					finf[max_loop].flen = len;
					finf[max_loop].had = adr+seg;
					max_loop++;
				} else if( (finf[max_loop-1].had + finf[max_loop-1].flen) == (adr + seg) ) {
					finf[max_loop-1].flen += len;
				} else {
					if( max_loop == MAX_TABLE ) {
						printf( "Table over flow\n" );
						fclose( fpr );
						if( fpw != NULL ) {
							fclose( fpw );
						}
						return( -1 );
					}
					finf[max_loop].fad = fadr;
					finf[max_loop].flen = len;
					finf[max_loop].had = adr+seg;
					max_loop++;
				}
			} else if( strncmp( bf1+7, "01", 2 ) == 0 ) {
				/*	I	*/
			} else if( strncmp( (bf1+7), "02", 2 ) == 0 ) {
				/*	gAhXw	*/
				bf2[4] = 0x00;
				strncpy( bf2, (bf1+9), 4 );
				sscanf( bf2, "%lx", &seg );
				seg <<= 4L;
			} else if( strncmp( (bf1+7), "04", 2 ) == 0 ) {
				/*	gAhXw	*/
				bf2[4] = 0x00;
				strncpy( bf2, (bf1+9), 4 );
				sscanf( bf2, "%lx", &seg );
				seg <<= 16L;
			}
			break;
		}
	}
	/*	HEX t@C̃AhXɃ\[g	*/
	do {
		flg = 0;
		for( m=0; m<(max_loop-1); m++ ) {
			if( finf[m].had > finf[m+1].had ) {
				memcpy( &finf[MAX_TABLE], &finf[m+1], sizeof( struct _finf ) );
				memcpy( &finf[m+1], &finf[m], sizeof( struct _finf ) );
				memcpy( &finf[m], &finf[MAX_TABLE], sizeof( struct _finf ) );
				flg = 1;
			}
		}
	} while( flg );
	switch( mode ) {
	case	D_MOTO:
		for( m=0; m<max_loop; m++ ) {
			fseek( fpr, finf[m].fad, 0 );
			out_len = 0L;
			while( fgets( bf1, 100, fpr ) != NULL ) {
				if( strchr( "123", *(bf1+1) ) != NULL ) {	/*	data	*/
					strncpy( bf2, (bf1+2), 2 );
					bf2[2] = 0x00;
					sscanf( bf2, "%x", &len );
					if( *(bf1+1) == '1' ) {
						/* 2byte AhX */
						len-=3;	/*	check sum,address 	*/
						p = bf1+8;	/* f[^̐擪w悤ɂ */
					} else if( *(bf1+1) == '2' ) {
						/* 3byte AhX */
						len-=4;	/*	check sum,address 	*/
						p = bf1+10;	/* f[^̐擪w悤ɂ */
					} else {
						/* 4byte AhX */
						len-=5;	/*	check sum,address 	*/
						p = bf1+12;	/* f[^̐擪w悤ɂ */
					}
					/*	f[^	*/
					bf2[2] = 0x00;
					for( n=0; n<len; n++ ) {
						strncpy( bf2, (p+n*2), 2 );
						sscanf( bf2, "%x", &dt );
						if( mhex( 0, finf[m].had+out_len,
								(unsigned char)dt, fpw ) == -1 ) {
							printf( "Not support address\n" );
							fclose( fpr );
							if( fpw != NULL ) {
								fclose( fpw );
							}
							return( -1 );
						}
						out_len++;
					}
					if( finf[m].flen == out_len ) {
						break;
					}
				}
			}
		}
		break;
	case	D_INTEL:
		for( m=0; m<max_loop; m++ ) {
			fseek( fpr, finf[m].fad, 0 );
			out_len = 0L;
			while( fgets( bf1, 100, fpr ) != NULL ) {
				if( strncmp( bf1+7, "00", 2 ) == 0 ) {
					/*	f[^	*/
					strncpy( bf2, bf1 + 1, 2 );
					bf2[2] = 0x00;
					sscanf( bf2, "%x", &len );		/*	f[^擾	*/
					for( n=0; n<len; n++ ) {
						strncpy( bf2, bf1+n*2+9, 2 );
						sscanf( bf2, "%x", &dt );
						ihex( 0, (unsigned long)(finf[m].had+out_len),
								(unsigned char)dt, fpw );
						out_len++;
					}
					if( finf[m].flen == out_len ) {
						break;
					}
				}
			}
		}
		break;
	default:
		fclose( fpr );
		printf( "infile format error\n" );
		if( fpw != NULL ) {
			fclose( fpw );
		}
		return( -1 );
	}
	fclose( fpr );
	switch( mode ) {
	case	D_MOTO:
		mhex_out( 0, fpw );
		mhex_end( fpw );
		break;
	case	D_INTEL:
		ihex_out( 0, fpw );
		ihex_end( fpw );
		break;
	}
	if( fpw != NULL ) {
		fclose( fpw );
	}
	return( 0 );
}

#ifdef	PROTOTYPE1
void	help( void )
#else
void	help()
#endif
{
	printf( "%s\n\n", Copyright );
	printf( "AhXύX\n" );
	printf( "  (1)hex_ut infile +xxxxx outfile\n" );
	printf( "  (2)hex_ut infile -xxxxx outfile\n" );
	printf( "      infile  : Intel HEX or ۰ S\n" );
	printf( "      +xxxxx  : LAhXZ(16i)\n" );
	printf( "      -xxxxx  : LAhXZ(16i)\n" );
	printf( "      outfile : o̓t@C(ȗ͉ʏo)\n" );
	printf( "tH[}bgϊ\n" );
	printf( "  (3)hex_ut infile option outfile[,xx]\n" );
	printf( "      infile  : Intel HEX or ۰ S or Binary\n" );
	printf( "      option                          option\n" );
	printf( "       -IS : Intel HEX -> ۰ S      -IB : Intel HEX -> Binary \n" );
	printf( "       -SI : ۰ S   -> Intel HEX    -SB : ۰ S   -> Binary \n" );
	printf( "       -BI : Binary    -> Intel HEX    -BS : Binary    -> ۰ S\n" );
	printf( "      outfile : et@C(ȗBinaryȊO͉ʏo)\n" );
	printf( "      ,xx     : Binary̖gp̈R[h(16i,ʏff)\n" );
	printf( "tH[}bg`\n" );
	printf( "  (4)hex_ut infile -F outfile\n" );
	printf( "      infile  : Intel HEX or ۰ S\n" );
	printf( "      outfile : o̓t@C(ȗ͉ʏo)\n" );
}

#ifdef	PROTOTYPE1
int	main( int ar, char *av[] )
#else
int	main( ar, av )
int	ar;
char	*av[];
#endif
{
	int		rc, in, out;
	long	offset;
	char	*p, *infile, *outfile;

	if( ar < 3 || ar > 4 ) {
		help();
		return( 1 );
	}
	infile = av[1];
	if( access( infile, 0 ) != 0 ) {
		printf( "t@CL܂ [%s]\n", infile );
		return( 1 );
	}
	outfile = NULL;
	if( ar == 4 ) {
		outfile = av[3];
		if( strcmp( infile, outfile ) == 0 ) {
			printf( "o̓t@Cł\n" );
			return( 1 );
		}
	}
	/*	啶ɒ	*/
	p = av[2];
	while( *p != 0x00 ) {
		*p = toupper( *p );
		p++;
	}
	in = out = 0;
	p = av[2];
	if( strcmp( p, "-IS" ) == 0 ) {
		in = D_INTEL;
		out = D_MOTO;
	} else if( strcmp( p, "-IB" ) == 0 ) {
		in = D_INTEL;
		out = D_BIN;
	} else if( strcmp( p, "-SI" ) == 0 ) {
		in = D_MOTO;
		out = D_INTEL;
	} else if( strcmp( p, "-SB" ) == 0 ) {
		in = D_MOTO;
		out = D_BIN;
	} else if( strcmp( p, "-BI" ) == 0 ) {
		in = D_BIN;
		out = D_INTEL;
	} else if( strcmp( p, "-BS" ) == 0 ) {
		in = D_BIN;
		out = D_MOTO;
	}
	if( in == 0 ) {
		if( strcmp( p, "-F" ) == 0 ) {
			/*	tH[}bg`	*/
			printf( "Convert start!!!\n" );
			rc = format_conv( infile, outfile );
		} else {
			/*	ItZbgAhXύX	*/
			sscanf( &av[2][1], "%lx", &offset );
			if( offset == 0L ) {
				help();
				return( 1 );
			}
			printf( "Convert start(address change)!!!\n" );
			if( *av[2] == '-' ) {
				rc = offset_change( infile, -offset, outfile );
			} else {
				rc = offset_change( infile, offset, outfile );
			}
		}
	} else {
		if( out == D_BIN ) {
			if( outfile == NULL ) {
				printf( "o̓t@Cw肵ĉ\n" );
				return( 1 );
			}
			if( (p = strchr( outfile, ',' )) != NULL ) {
				*p = 0x00;
				sscanf( p+1, "%x", &Fill_code );
			}
		}
		if( outfile != NULL ) {
			if( out != D_BIN && strchr( outfile, ',' ) != NULL ) {
				printf( "o̓t@CԈĂ܂\n" );
				return( 1 );
			}
		}
		/*	tH[}bgϊ	*/
		printf( "Convert start(format change)!!!\n" );
		rc = fmt_conv( in, out, infile, outfile );
	}
	if( rc == 0 ) {
		printf( "Convert end!!!\n\n" );
		return( 0 );
	} else {
		printf( "Convert error end!!!\n\n" );
		return( 1 );
	}
}
